/*
 * da9052 Backlight module declarations.
 *
 * Copyright(c) 2009 Dialog Semiconductor Ltd.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */

#ifndef __LINUX_MFD_DA9052_BL_H
#define __LINUX_MFD_DA9052_BL_H

/*
 * enum da9052_bl_current_value - Enum for current values of LED
 * DA9052_BL_CURRENT_50_0UA: represents 50.0 uA current value
 */
enum da9052_bl_current_value {
/* Current Value for LEDMIN, LED1_CONF, LED2_CONF, LED3_CONF Registers */
	DA9052_BL_CURRENT_50_0UA = 0,
	DA9052_BL_CURRENT_51_2UA,
	DA9052_BL_CURRENT_52_5UA,
	DA9052_BL_CURRENT_53_7UA,
	DA9052_BL_CURRENT_55_1UA,
	DA9052_BL_CURRENT_56_4UA,
	DA9052_BL_CURRENT_57_8UA,
	DA9052_BL_CURRENT_59_3UA,
	DA9052_BL_CURRENT_60_7UA,
	DA9052_BL_CURRENT_62_2UA,
	DA9052_BL_CURRENT_63_8UA,
	DA9052_BL_CURRENT_65_3UA,
	DA9052_BL_CURRENT_67_0UA,
	DA9052_BL_CURRENT_68_6UA,
	DA9052_BL_CURRENT_70_3UA,
	DA9052_BL_CURRENT_72_0UA,
	DA9052_BL_CURRENT_73_8UA,
	DA9052_BL_CURRENT_75_7UA,
	DA9052_BL_CURRENT_77_5UA,
	DA9052_BL_CURRENT_79_4UA,
	DA9052_BL_CURRENT_81_4UA,
	DA9052_BL_CURRENT_83_4UA,
	DA9052_BL_CURRENT_85_5UA,
	DA9052_BL_CURRENT_87_6UA,
	DA9052_BL_CURRENT_89_8UA,
	DA9052_BL_CURRENT_92_0UA,
	DA9052_BL_CURRENT_94_2UA,
	DA9052_BL_CURRENT_96_6UA,
	DA9052_BL_CURRENT_99_0UA,
	DA9052_BL_CURRENT_101_4UA,
	DA9052_BL_CURRENT_103_9UA,
	DA9052_BL_CURRENT_106_5UA,
	DA9052_BL_CURRENT_109_1UA,
	DA9052_BL_CURRENT_111_8UA,
	DA9052_BL_CURRENT_114_6UA,
	DA9052_BL_CURRENT_117_4UA,
	DA9052_BL_CURRENT_120_6UA,
	DA9052_BL_CURRENT_123_3UA,
	DA9052_BL_CURRENT_126_3UA,
	DA9052_BL_CURRENT_129_4UA,
	DA9052_BL_CURRENT_132_6UA,
	DA9052_BL_CURRENT_135_9UA,
	DA9052_BL_CURRENT_139_3UA,
	DA9052_BL_CURRENT_142_7UA,
	DA9052_BL_CURRENT_146_2UA,
	DA9052_BL_CURRENT_149_9UA,
	DA9052_BL_CURRENT_153_6UA,
	DA9052_BL_CURRENT_157_4UA,
	DA9052_BL_CURRENT_161_2UA,
	DA9052_BL_CURRENT_165_2UA,
	DA9052_BL_CURRENT_169_3UA,
	DA9052_BL_CURRENT_173_5UA,
	DA9052_BL_CURRENT_177_8UA,
	DA9052_BL_CURRENT_182_2UA,
	DA9052_BL_CURRENT_186_7UA,
	DA9052_BL_CURRENT_191_3UA,
	DA9052_BL_CURRENT_196_0UA,
	DA9052_BL_CURRENT_200_9UA,
	DA9052_BL_CURRENT_205_8UA,
	DA9052_BL_CURRENT_210_9UA,
	DA9052_BL_CURRENT_216_1UA,
	DA9052_BL_CURRENT_221_4UA,
	DA9052_BL_CURRENT_226_9UA,
	DA9052_BL_CURRENT_232_5UA,
	DA9052_BL_CURRENT_238_3UA,
	DA9052_BL_CURRENT_244_2UA,
	DA9052_BL_CURRENT_250_2UA,
	DA9052_BL_CURRENT_256_4UA,
	DA9052_BL_CURRENT_262_7UA,
	DA9052_BL_CURRENT_269_2UA,
	DA9052_BL_CURRENT_275_8UA,
	DA9052_BL_CURRENT_282_7UA,
	DA9052_BL_CURRENT_289_6UA,
	DA9052_BL_CURRENT_296_8UA,
	DA9052_BL_CURRENT_304_1UA,
	DA9052_BL_CURRENT_311_6UA,
	DA9052_BL_CURRENT_319_3UA,
	DA9052_BL_CURRENT_327_2UA,
	DA9052_BL_CURRENT_335_3UA,
	DA9052_BL_CURRENT_343_6UA,
	DA9052_BL_CURRENT_352_1UA,
	DA9052_BL_CURRENT_360_8UA,
	DA9052_BL_CURRENT_369_7UA,
	DA9052_BL_CURRENT_378_8UA,
	DA9052_BL_CURRENT_388_2UA,
	DA9052_BL_CURRENT_397_8UA,
	DA9052_BL_CURRENT_407_6UA,
	DA9052_BL_CURRENT_417_7UA,
	DA9052_BL_CURRENT_428_0UA,
	DA9052_BL_CURRENT_438_6UA,
	DA9052_BL_CURRENT_449_4UA,
	DA9052_BL_CURRENT_460_5UA,
	DA9052_BL_CURRENT_471_9UA,
	DA9052_BL_CURRENT_483_5UA,
	DA9052_BL_CURRENT_495_5UA,
	DA9052_BL_CURRENT_507_7UA,
	DA9052_BL_CURRENT_520_3UA,
	DA9052_BL_CURRENT_533_1UA,
	DA9052_BL_CURRENT_546_3UA,
	DA9052_BL_CURRENT_559_8UA,
	DA9052_BL_CURRENT_573_6UA,
	DA9052_BL_CURRENT_587_8UA,
	DA9052_BL_CURRENT_602_3UA,
	DA9052_BL_CURRENT_617_2UA,
	DA9052_BL_CURRENT_632_4UA,
	DA9052_BL_CURRENT_648_0UA,
	DA9052_BL_CURRENT_664_0UA,
	DA9052_BL_CURRENT_680_4UA,
	DA9052_BL_CURRENT_697_2UA,
	DA9052_BL_CURRENT_714_5UA,
	DA9052_BL_CURRENT_732_1UA,
	DA9052_BL_CURRENT_750_2UA,
	DA9052_BL_CURRENT_768_7UA,
	DA9052_BL_CURRENT_787_7UA,
	DA9052_BL_CURRENT_807_2UA,
	DA9052_BL_CURRENT_827_1UA,
	DA9052_BL_CURRENT_847_6UA,
	DA9052_BL_CURRENT_868_5UA,
	DA9052_BL_CURRENT_889_9UA,
	DA9052_BL_CURRENT_911_9UA,
	DA9052_BL_CURRENT_934_4UA,
	DA9052_BL_CURRENT_957_5UA,
	DA9052_BL_CURRENT_981_2UA,
	DA9052_BL_CURRENT_1005_4UA,
	DA9052_BL_CURRENT_1030_3UA,
	DA9052_BL_CURRENT_1055_7UA,
	DA9052_BL_CURRENT_1081_8UA,
	DA9052_BL_CURRENT_1108_5UA,
	DA9052_BL_CURRENT_1135_9UA,
	DA9052_BL_CURRENT_1163_9UA,
	DA9052_BL_CURRENT_1192_7UA,
	DA9052_BL_CURRENT_1222_2UA,
	DA9052_BL_CURRENT_1252_3UA,
	DA9052_BL_CURRENT_1283_3UA,
	DA9052_BL_CURRENT_1315_0UA,
	DA9052_BL_CURRENT_1347_5UA,
	DA9052_BL_CURRENT_1380_7UA,
	DA9052_BL_CURRENT_1414_8UA,
	DA9052_BL_CURRENT_1449_8UA,
	DA9052_BL_CURRENT_1485_6UA,
	DA9052_BL_CURRENT_1522_3UA,
	DA9052_BL_CURRENT_1559_9UA,
	DA9052_BL_CURRENT_1598_4UA,
	DA9052_BL_CURRENT_1637_9UA,
	DA9052_BL_CURRENT_1678_4UA,
	DA9052_BL_CURRENT_1719_8UA,
	DA9052_BL_CURRENT_1762_3UA,
	DA9052_BL_CURRENT_1805_8UA,
	DA9052_BL_CURRENT_1850_4UA,
	DA9052_BL_CURRENT_1896_1UA,
	DA9052_BL_CURRENT_1943_0UA,
	DA9052_BL_CURRENT_1991_0UA,
	DA9052_BL_CURRENT_2040_2UA,
	DA9052_BL_CURRENT_2090_5UA,
	DA9052_BL_CURRENT_2142_2UA,
	DA9052_BL_CURRENT_2195_1UA,
	DA9052_BL_CURRENT_2249_3UA,
	DA9052_BL_CURRENT_2304_9UA,
	DA9052_BL_CURRENT_2361_8UA,
	DA9052_BL_CURRENT_2420_1UA,
	DA9052_BL_CURRENT_2479_9UA,
	DA9052_BL_CURRENT_2541_2UA,
	DA9052_BL_CURRENT_2604_0UA,
	DA9052_BL_CURRENT_2668_3UA,
	DA9052_BL_CURRENT_2734_2UA,
	DA9052_BL_CURRENT_2801_7UA,
	DA9052_BL_CURRENT_2870_9UA,
	DA9052_BL_CURRENT_2941_8UA,
	DA9052_BL_CURRENT_3014_5UA,
	DA9052_BL_CURRENT_3089_0UA,
	DA9052_BL_CURRENT_3165_3UA,
	DA9052_BL_CURRENT_3243_4UA,
	DA9052_BL_CURRENT_3323_5UA,
	DA9052_BL_CURRENT_3405_6UA,
	DA9052_BL_CURRENT_3489_8UA,
	DA9052_BL_CURRENT_3576_0UA,
	DA9052_BL_CURRENT_3664_3UA,
	DA9052_BL_CURRENT_3754_8UA,
	DA9052_BL_CURRENT_3847_5UA,
	DA9052_BL_CURRENT_3942_6UA,
	DA9052_BL_CURRENT_4040_0UA,
	DA9052_BL_CURRENT_4139_7UA,
	DA9052_BL_CURRENT_4242_0UA,
	DA9052_BL_CURRENT_4346_8UA,
	DA9052_BL_CURRENT_4454_1UA,
	DA9052_BL_CURRENT_4564_2UA,
	DA9052_BL_CURRENT_4676_9UA,
	DA9052_BL_CURRENT_4792_4UA,
	DA9052_BL_CURRENT_4910_8UA,
	DA9052_BL_CURRENT_5032_1UA,
	DA9052_BL_CURRENT_5156_4UA,
	DA9052_BL_CURRENT_5283_7UA,
	DA9052_BL_CURRENT_5414_3UA,
	DA9052_BL_CURRENT_5548_0UA,
	DA9052_BL_CURRENT_5685_0UA,
	DA9052_BL_CURRENT_5825_5UA,
	DA9052_BL_CURRENT_5969_3UA,
	DA9052_BL_CURRENT_6116_8UA,
	DA9052_BL_CURRENT_6267_9UA,
	DA9052_BL_CURRENT_6422_7UA,
	DA9052_BL_CURRENT_6581_3UA,
	DA9052_BL_CURRENT_6743_9UA,
	DA9052_BL_CURRENT_6910_5UA,
	DA9052_BL_CURRENT_7081_2UA,
	DA9052_BL_CURRENT_7256_1UA,
	DA9052_BL_CURRENT_7435_3UA,
	DA9052_BL_CURRENT_7618_9UA,
	DA9052_BL_CURRENT_7807_1UA,
	DA9052_BL_CURRENT_8000_0UA,
	DA9052_BL_CURRENT_8197_6UA,
	DA9052_BL_CURRENT_8400_0UA,
	DA9052_BL_CURRENT_8607_5UA,
	DA9052_BL_CURRENT_8820_1UA,
	DA9052_BL_CURRENT_9038_0UA,
	DA9052_BL_CURRENT_9261_2UA,
	DA9052_BL_CURRENT_9490_0UA,
	DA9052_BL_CURRENT_9724_4UA,
	DA9052_BL_CURRENT_9964_6UA,
	DA9052_BL_CURRENT_10210_7UA,
	DA9052_BL_CURRENT_10462_9UA,
	DA9052_BL_CURRENT_10721_4UA,
	DA9052_BL_CURRENT_10986_4UA,
	DA9052_BL_CURRENT_11257_5UA,
	DA9052_BL_CURRENT_11535_6UA,
	DA9052_BL_CURRENT_11820_5UA,
	DA9052_BL_CURRENT_12112_5UA,
	DA9052_BL_CURRENT_12411_7UA,
	DA9052_BL_CURRENT_12718_2UA,
	DA9052_BL_CURRENT_13032_4UA,
	DA9052_BL_CURRENT_13354_3UA,
	DA9052_BL_CURRENT_13684_1UA,
	DA9052_BL_CURRENT_14022_1UA,
	DA9052_BL_CURRENT_14368_5UA,
	DA9052_BL_CURRENT_14723_4UA,
	DA9052_BL_CURRENT_15087_1UA,
	DA9052_BL_CURRENT_15459_7UA,
	DA9052_BL_CURRENT_15841_6UA,
	DA9052_BL_CURRENT_16232_9UA,
	DA9052_BL_CURRENT_16633_8UA,
	DA9052_BL_CURRENT_17044_7UA,
	DA9052_BL_CURRENT_17465_7UA,
	DA9052_BL_CURRENT_17897_1UA,
	DA9052_BL_CURRENT_18339_1UA,
	DA9052_BL_CURRENT_18792_1UA,
	DA9052_BL_CURRENT_19256_3UA,
	DA9052_BL_CURRENT_19731_9UA,
	DA9052_BL_CURRENT_20219_3UA,
	DA9052_BL_CURRENT_20718_7UA,
	DA9052_BL_CURRENT_21230_5UA,
	DA9052_BL_CURRENT_21754_8UA,
	DA9052_BL_CURRENT_22292_2UA,
	DA9052_BL_CURRENT_22842_8UA,
	DA9052_BL_CURRENT_23407_0UA,
	DA9052_BL_CURRENT_23985_2UA,
	DA9052_BL_CURRENT_24577_6UA,
	DA9052_BL_CURRENT_25000_0UA,
};

#endif /* __LINUX_MFD_DA9052_BL_H */
